代码随想录 300.最长递增子序列

思路:根据题意得,子序列是由数组派生而来的序列,删除(或不删除)数组中的元素不改变其余元素的顺序。

动规五部曲:

1.dpi的定义:dpi表示i之前包括i的以numsi结尾的最长递增子序列的长度。

2.确定递推公式(状态转移方程):

(1)位置i的最长递增子序列等于j从0到i - 1各个位置的最长递增子序列 + 1的最大值。

(2)所以:if(numsi > numsj) dpi = max(dpi,dpj + 1)。(这里不是将dpi与dpj + 1比较,而是选取dpj + 1的最大值)。

3.dpi的初始化:每一个i,对应的dpi(即最长递增子序列)起始大小至少都是1。

4.确定遍历顺序:

(1)dpi是由0到i - 1各个位置的最长递增子序列推导而来,因此遍历i一定是从前向后遍历。

(2)j就是遍历0到i - 1,因此从前到后或从后到前的遍历顺序都无所谓,只要把0到i - 1的元素都遍历到就行。默认习惯为从前到后遍历。

遍历i的循环在外层,遍历j的循环在内层,代码如下所示:

cpp 复制代码
for (int i = 1; i < nums.size(); i++) {
    for (int j = 0; j < i; j++) {
        if (nums[i] > nums[j]) dp[i] = max(dp[i], dp[j] + 1);
    }
    if (dp[i] > result) result = dp[i]; // 取长的子序列
}

5.举例推导dp数组:输入:0,1,0,3,2,dp数组的变化如下所示。

附代码:

java 复制代码
class Solution {
    public int lengthOfLIS(int[] nums) {
        if(nums.length <= 1){
            return nums.length;
        }
        int res = 1;
        int[] dp = new int[nums.length];
        for(int i = 0;i < nums.length;i++){
            dp[i] = 1;
        }
        for(int i = 1;i < nums.length;i++){
            for(int j = 0;j < i;j++){
                if(nums[i] > nums[j]){
                    dp[i] = Math.max(dp[i],dp[j] + 1);
                }
            }
            res = Math.max(res,dp[i]);
        }
        return res;
    }
}
相关推荐
UIU1148 小时前
P1233 [ICPC 2001 Taejon R] 木棍加工
数据结构·c++·算法·动态规划
论文复现现场9 小时前
WRF、FEA 能用 L40S 加速吗?求解器检查、断点恢复与长期运行
java·数据库·算法·wrf·有限元分析·gpu计算·断点续算
ZhengEnCi9 小时前
用 AI 写代码为什么拼到最后还是拼人:算力瓶颈与领域专家提示词的本质差异
算法·架构
秋天的怀念_David10 小时前
第二十一夜 · 数字黑洞与西西弗斯的惩罚
java·程序人生·算法
碧海银沙音频科技研究院11 小时前
在PC电脑上用Whisper→Marian算法实现离线语音翻译功能
算法·whisper
niyongsheng11 小时前
3D 装箱算法工程化:数据结构、放置启发式与支撑规则
数据结构·算法·rust
j7~14 小时前
【穷举、深搜与回溯算法】一棵决策树讲透全排列与子集
数据结构·c++·算法·leetcode·回溯·递归
傅科摆 _ py14 小时前
DP,贪心,堆和栈,二分力扣复习
开发语言·python·算法
Shaoshing15 小时前
LeetCode100 42.接雨水
java·算法·leetcode
域限奇点访客15 小时前
用AI生成问卷的网站怎么选?看题目录入结构、题型映射和生成后的校验
算法